	include "P16f877.inc"
        __CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON & _HS_OSC & _WRT_ENABLE_OFF & _LVP_OFF & _DEBUG_OFF & _CPD_OFF
;	This version oct 27 includes Fahrenheit operation and on/off switch, debounce issue is solved. 
;	Also decrementing at 122 after reset has also been solved.
; --------------------
; USER RAM DEFINITIONS
; --------------------
	CBLOCK 0x20
	
	DelayL   ;u
	DelayM   ;u
	DelayH   ;u
	Index    ;u
	Temp     ;u
	Temp2    ;???
	Temp22   ;
	DelayL1  ;u
	firstt
              Temp1d1  ;temperature 1  digit1 (lsb)
	Temp1d2  ;temperature 1  digit2 
	Temp1d3  ;temperature 1  digit3 (msb)

	Temp2d1  ;temperature 2  digit1 (lsb)
	Temp2d2  ;temperature 2  digit2 
	Temp2d3  ;temperature 2  digit3 (msb)
	Tempincre
	Tempincre2
	Test122
	Test2122    
	Keephigh
	Keeplow
	Keeplow21
	Keephigh21

	ENDC
; -----------Definitions
ADDR	      EQU     0x02
w_temp        EQU     0x70        ; variable used for context saving 
status_temp   EQU     0x71        ; variable used for context saving		; 
;
	ORG     0x000             ; processor reset vector
	clrf    PCLATH            ; ensure page bits are cleared
  	goto    main              ; go to beginning of program


	ORG     0x004             ; interrupt vector location
	movwf   w_temp            ; save off current W register contents
	movf	STATUS,w          ; move status register into W register
	movwf	status_temp       ; save off contents of STATUS register


; isr code can go here or be located as a call subroutine elsewhere

	movf    status_temp,w     ; retrieve copy of STATUS register
	movwf	STATUS            ; restore pre-isr STATUS register contents
	swapf   w_temp,f
	swapf   w_temp,w          ; restore pre-isr W register contents
	retfie                    ; return from interrupt

; -----------------
; ---------------------
; CODE BEGINS HERE
; ---------------------
;


main	nop



	call Portsinit
	movlw 0x02
	movwf Temp1d1 
	movlw 0x02
	movwf Temp1d2 
	movlw 0x01
	movwf Temp1d3

	movlw 0x02
	movwf Temp2d1 
	movlw 0x02
	movwf Temp2d2 
	movlw 0x01
	movwf Temp2d3
	
	bsf PORTA, 2		     ;Turn off LCD through PNP
	bcf PORTA, 3		     ;Enable On push bottom through PNP 
	banksel OPTION_REG
	bsf   OPTION_REG, INTEDG     ; 6, enable external interrupt on rising edge 
	bsf   INTCON, INTE	     ; 4 Enable the interrupt 
	sleep
	nop
;zzzzzzzzzzzzzzzzzzzzzzzzzzz
StartFS	
	call  Aisleep			     ;lcd init, check for key three, etcc...
	call Line1F
	call Line2F	
	bsf  Test122, 0
	bsf  Test2122,0
;=F=F=F=F=F=F=F=F=F=F=F=F=F=F====
MainF	
	call ChekforKey45   ;key5 increments quemador 1
	call Chekforkey21   ;key2 increments quemador 2
	call SendtempF1
	call SendtempF2
	call Onoff
	
	goto MainF
;=F=F=F=F=F=F=F=F=F=F=F=F=F=F====


StartF	
	call   WEEprom	

	goto  StartFS

Fin
	goto Fin

;******************************************************
Line1F
	clrf Index
	bsf PORTD, 0     ; set d0 to high/select data register
	call QEM1FF
	
	movlw 0xC0
	movwf PORTB
	call  Sendcont
	Return
;////////////////////////////////////////////////////
;***************************************************
Line2F
	clrf Index
	call QEM2FF
	movlw 0x0C
	movwf PORTB
	call Sendcont
	Return
;//////////////////////////////////////////////////////
;*****************************************************
;----------------STRING 1---------------
QEM1FF
	MOVF Index, W
	CALL LETTFF	; map index into a character
	ADDLW 0		; perform an arithmetic function to set Z flag
	BTFSC STATUS, Z
	return		; character was 00H
	INCF Index, F
	movwf PORTB
	call Enable
	GOTO QEM1FF

	
LETTFF	ADDWF PCL, F
	DT  "TEMP #1 =122", 00H            ;   
;///////////////////////////////////////////////////
;***************************************************
;---------------STRING 2----------------
QEM2FF
	MOVF Index, W
	CALL LETT2FF	; map index into a character
	ADDLW 0		; perform an arithmetic function to set Z flag
	BTFSC STATUS, Z
	return		; character was 00H
	INCF Index, F
	movwf PORTB
	call Enable
	GOTO QEM2FF

	
LETT2FF	ADDWF PCL, F
	DT  "TEMP #2 =122", 00H       

;///////////////////////////////////////
;********************************
Aisleep
	bcf   INTCON, INTE	     ; 4 disable the interrupt 
	bcf   INTCON, INTF           ; clear the flag in software 

	bcf PORTA, 2		;Turn on LCD
        bsf PORTA, 3		;Disable Pushbotton
	call Lcdinit
	call ChekforKey3FC
	movlw 0x10   
	movwf DelayL1
bigdelay call BigDel	
	decfsz DelayL1
        goto bigdelay

	call Clearlcd
	
	clrf Keephigh
	clrf Keeplow
	return	
;/////////////////////////
;***************************************
Onoff
	bcf PORTA, 3		     ;Enable On push bottom through PNP 
	banksel OPTION_REG           ;
	bsf   OPTION_REG, INTEDG     ; 6, enable external interrupt on rising edge 
	bsf   INTCON, INTE	     ; 4 Enable the interrupt 
	btfss INTCON, INTF	     ; if set turn unit off and goto sleep 	
	goto  SkipGoodbye
	
	bsf PORTA, 2                  ;Turn off LCD through PNP
	movlw 0x25                    ;leave for button debounce
	movwf DelayL1
bigdelG call BigDel	
	decfsz DelayL1
        goto bigdelG
	BANKSEL PORTB
	clrf	PORTB	
	banksel OPTION_REG
	bcf   INTCON, INTF            ; clear the flag in software right before sleep, and after debounce
	;sleep
	nop                           ;datasheet
	movlw 0x11 
	movwf DelayL1
bigdelH call BigDel	
	decfsz DelayL1
        goto bigdelH
	goto  StartF 			
SkipGoodbye
	bsf PORTA, 3		     ;disable push bottom through PNP 
	return
;///////////////////////////////////////
;***************************************
ChekforKey3FC

        bsf  STATUS, RP0	; return to bank 1 to use I/O ports	
	movlw 0x14
	movwf PORTB
	movlw 0x03      ;
	movwf DelayL1
loop2IF  call Sendcont	
	decfsz DelayL1
        goto loop2IF


;---------
	clrf Index
	bsf PORTD, 0     ; set d0 to high/select data register
	call QEMF
	
	movlw 0xC0
	movwf PORTB
	call  Sendcont
;-------------
QEMF
	MOVF Index, W
	CALL LETTF	; map index into a character
	ADDLW 0		; perform an arithmetic function to set Z flag
	BTFSC STATUS, Z
	return		; character was 00H
	INCF Index, F
	movwf PORTB
	call Enable
	GOTO QEMF

	
LETTF	ADDWF PCL, F
	DT  "FAHRENHEIT", 00H            

	return
;///////////////////////////////////////
ChekforKey45

       bcf STATUS,RP0
       bcf STATUS,RP1   ; go to bank 0
       
 
        movf PORTD, 0
        movwf Temp	
        btfss Temp, 4
        goto loop31
        goto gotit
loop31  btfss Temp, 5
        goto endcheck2		
        goto endcheck 
gotit   bsf  STATUS, RP0
	incf Keeplow
	btfss Keeplow, 3
	goto dectwice
	goto compdec
	
dectwice
	call Decrement
	call Decrement
	goto endfromcomph

compdec
	call Decrement
	call Decrement
	call Decrement
	call Decrement
	call Decrement
	call Decrement
	call Decrement
	call Decrement
	goto endfromcomph


endcheck bsf  STATUS, RP0	; return to bank 1 to use 
	incf Keephigh
	btfss Keephigh, 3
	goto inctwice	
	goto comphigh
	 

inctwice
	call Increment
	call Increment
	goto endfromcomph
comphigh
	call Increment
	call Increment	
	call Increment
	call Increment
	call Increment
	call Increment	
	call Increment
	call Increment
	goto endfromcomph
endchkhigh

endcheck2   
	bsf  STATUS, RP0   
  	clrf Keephigh
	clrf Keeplow
endfromcomph
	
	return
;////////////////////////////////////////

;***************************************
Increment
;-------------------------------------00x

	bsf PORTA, 0	;if incrementing remeber to keep the burner high 	
	clrf Test122   ; set so that we can decrement after reaching 122
	
		
	btfsc Temp1d1, 0  ; check for 0 in row 1
	goto  Contasnormal
	btfsc Temp1d1, 1  ; 
	goto  Contasnormal 
	btfsc Temp1d1, 2
	goto  Contasnormal
	btfsc Temp1d1, 3
	goto  Contasnormal
	goto  checkrow2I                ;if true it is a zero


checkrow2I
	
	btfsc Temp1d2, 0  ; check for 0 in row 2
	goto  Contasnormal
	btfsc Temp1d2, 1  
	goto  Contasnormal  
	btfsc Temp1d2, 2
	goto  Contasnormal
	btfsc Temp1d2, 3
	goto  Contasnormal
	goto  checkrow3I      



checkrow3I 
	
	btfsc Temp1d3, 0  ; check for 4 in row 3
	goto  Contasnormal
	btfsc Temp1d3, 1  
	goto  Contasnormal
	btfss Temp1d3, 2
	goto  Contasnormal
	btfsc Temp1d3, 3
	goto  Contasnormal
	goto  Endincre




; check first then increment

Contasnormal
	incf Temp1d1, 1




	
	movlw 0x02
	movwf PORTB
	call Sendcont


	movlw 0x14
	movwf PORTB
	movlw 0x0B      ;11 times
	movwf DelayL1
loop2I  call Sendcont	
	decfsz DelayL1
        goto loop2I
	
	movlw 0x30
	addwf Temp1d1, 0   ;convert to ascii for LCD
	movwf PORTB         
	movwf Tempincre
	call Senddata

	btfss Tempincre, 3  ; check if 8,9,A 100x, I'm looking for a 9
	goto  Endincre
	btfss Tempincre, 1  ; check if A   1001
	goto Endincre       ;if not an 9 go to end of routine
	
	movlw 0x02          ;before leaving clear row 1 to zero/set tempincre to 1
	movwf PORTB
	call Sendcont
	movlw 0x14
	movwf PORTB
	movlw 0x0B      ;11 times
	movwf DelayL1
loop4I  call Sendcont	
	decfsz DelayL1
        goto loop4I


	movlw 0x30          ;
	movwf PORTB
	call Senddata
	clrf Temp1d1        ;very much needed.
	clrf Tempincre      ;needed?????     
	incf Temp1d2, 1
	goto  goto0x0
	
;--------------------------------0x0	       
goto0x0    ;routine for incrementing 2nd row/ 
	
	movlw 0x02
	movwf PORTB
	call Sendcont

	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x0A      ;10 times
	movwf DelayL1
loop3I  call Sendcont	
	decfsz DelayL1
        goto loop3I

	movlw 0x30
	addwf Temp1d2, 0   ;convert to ascii for LCD
	movwf PORTB         
	movwf Tempincre
	call Senddata

	btfss Tempincre, 3  ; check if 8,9,A 100x, I'm looking for a 9
	goto  Endincre
	btfss Tempincre, 1  ; check if A   1001
	goto Endincre       ;if not an 9 go to end of routine
	
	movlw 0x02          ;before leaving clear row to zero/set tempincre to 1
	movwf PORTB
	call Sendcont
	movlw 0x14
	movwf PORTB
	movlw 0x0A      ;10 times
	movwf DelayL1
loop5I  call Sendcont	
	decfsz DelayL1
        goto loop5I

	movlw 0x30          ;
	movwf PORTB
	call Senddata
	clrf Tempincre      ;needed?????     
;zzzzzzzzzzzzzz added when was working until 109
	clrf Temp1d1        ;very much needed.
	clrf Tempincre      ;needed?????     
;zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	incf Temp1d3, 1
	goto  gotox00
;-----------------------------------x00----------	      
gotox00

	movlw 0x02
	movwf PORTB
	call Sendcont

	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x09      ;10 times
	movwf DelayL1
loop6I  call Sendcont	
	decfsz DelayL1
        goto loop6I

	movlw 0x30
	addwf Temp1d3, 0   ;convert to ascii for LCD
	movwf PORTB         
	movwf Tempincre
	call Senddata

	clrf Temp1d1        ;very much needed.
	clrf Temp1d2        ;vmn
	clrf Tempincre      ;needed?????     

Endincre
	bcf PORTA, 0    ;
	Return
;//////////////////////////////////////

;**************************************
Decrement  

	btfsc Test122, 0
	goto enddecre


	btfsc Temp1d1, 0  ; check for 0 in row 1
	goto  outrow1
	btfsc Temp1d1, 1  ; 
	goto  outrow1    
	btfsc Temp1d1, 2
	goto  outrow1
	btfsc Temp1d1, 3
	goto  outrow1
	goto  checkrow2                ;if true it is a 0


checkrow2
	

	
	btfsc Temp1d2, 0  ; check for 0 in row 2
	goto  outrow2
	btfsc Temp1d2, 1    
	goto  outrow2    
	btfsc Temp1d2, 2
	goto  outrow2
	btfsc Temp1d2, 3
	goto  outrow2
	goto  checkrow3      



checkrow3 
	


	btfsc Temp1d3, 0  ; check for 0 in row 
	goto  outrow3
	btfsc Temp1d3, 1  
	goto  outrow3    
	btfsc Temp1d3, 2
	goto  outrow3
	btfsc Temp1d3, 3
	goto  outrow3
	goto  enddecre
;-----------------------------------------------00x
outrow1
	decf Temp1d1, 1       ;
	movlw 0x02
	movwf PORTB
	call Sendcont

	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x0B      ;11 times
	movwf DelayL1
loop3D  call Sendcont	
	decfsz DelayL1
        goto loop3D

	movlw 0x30
	addwf Temp1d1, 0   ;convert to ascii for LCD
	movwf PORTB         
	movwf Tempincre
	call Senddata
	goto enddecre

;---------------------------------------0x0
outrow2
	
	;first we must reset first column to 9
	
	movlw 0x02
	movwf PORTB
	call Sendcont
	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x0B      ;11 times
	movwf DelayL1
loopw2  call Sendcont	
	decfsz DelayL1
        goto loopw2
	movlw 0x09
	movwf Temp1d1 ;put 9 into temp1d1 but dont change when converting to ascii
	movlw 0x30  ;
	addwf Temp1d1, 0   ;convert to ascii for LCD
	movwf PORTB         
	call Senddata
;**
	decf Temp1d2, 1
;**
	movlw 0x02
	movwf PORTB
	call Sendcont

	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x0A      ;10 times
	movwf DelayL1
loop4D  call Sendcont	
	decfsz DelayL1
        goto loop4D

	movlw 0x30
	addwf Temp1d2, 0   ;convert to ascii for LCD
	movwf PORTB         
	movwf Tempincre
	call Senddata
	goto enddecre



;---------------------------------------x00
outrow3
	
	;first we must reset second and firts columns to 9

; first column
	movlw 0x02
	movwf PORTB
	call Sendcont
	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x0A      ;10 times
	movwf DelayL1
loopw3  call Sendcont	
	decfsz DelayL1
        goto loopw3



	movlw 0x09
	movwf Temp1d2
	movlw 0x30  ;
	addwf Temp1d2, 0   ;convert to ascii for LCD
	movwf PORTB         
	call Senddata
;first

	movlw 0x02
	movwf PORTB
	call Sendcont
	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x0B      ;11 times
	movwf DelayL1
loopw31  call Sendcont	
	decfsz DelayL1
        goto loopw31



	movlw 0x09
	movwf Temp1d1 ;reset it to 9
	movlw 0x30  ;
	addwf Temp1d2, 0   ;convert to ascii for LCD
	movwf PORTB         
	call Senddata



;***
	decf Temp1d3, 1
;***	
	movlw 0x02
	movwf PORTB
	call Sendcont

	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x09      ;9 times
	movwf DelayL1
loop5D  call Sendcont	
	decfsz DelayL1
        goto loop5D

	movlw 0x30
	addwf Temp1d3, 0   ;convert to ascii for LCD
	movwf PORTB         
	movwf Tempincre
	call Senddata
	goto enddecre



enddecre

;test for 122 



	btfsc Temp1d1, 0  ; check for 2 in row 1
	goto  enddrerou
	btfss Temp1d1, 1  ; 
	goto  enddrerou   
	btfsc Temp1d1, 2
	goto  enddrerou
	btfsc Temp1d1, 3
	goto  enddrerou
	goto  checkrow2F                ;if true it is a 2


checkrow2F
	

	
	btfsc Temp1d2, 0  ; check for 2 in row 2
	goto  enddrerou
	btfss Temp1d2, 1  
	goto  enddrerou    
	btfsc Temp1d2, 2
	goto  enddrerou
	btfsc Temp1d2, 3
	goto  enddrerou
	goto  checkrow3F      



checkrow3F 
	


	btfss Temp1d3, 0  ; check for 1 in row 3
	goto  enddrerou
	btfsc Temp1d3, 1  
	goto  enddrerou   
	btfsc Temp1d3, 2
	goto  enddrerou
	btfsc Temp1d3, 3
	goto  enddrerou
	movlw 0xFF
	movwf Test122
	
enddrerou
	Return
;//////////////////////////////////////

;**************************************
Chekforkey21
       bcf STATUS,RP0
       bcf STATUS,RP1   ; go to bank 0
       
 
         movf PORTD, 0
         movwf Temp22	
         btfss Temp22, 1
         goto loop71
         goto gotit2
loop71   btfss Temp22, 2
         goto endchk22  		
         goto endchk21 
gotit2   bsf  STATUS, RP0
	 incf Keeplow21
	btfss Keeplow21, 3
	goto dectwice21
	goto compdec21
	
dectwice21
	call Decrement2
	call Decrement2
	goto endfromcomph

compdec21
	call Decrement2
	call Decrement2
	call Decrement2
	call Decrement2
	call Decrement2
	call Decrement2
	call Decrement2
	call Decrement2
	goto endfromcomph21
	 
	
endchk21 bsf  STATUS, RP0	; return to bank 1 to use 
	incf Keephigh21
	btfss Keephigh21, 3
	goto inctwice21	
	goto comphigh21
	 

inctwice21
	call Increment2
	call Increment2
	goto endfromcomph21
comphigh21
	call Increment2
	call Increment2	
	call Increment2
	call Increment2
	call Increment2
	call Increment2	
	call Increment2
	call Increment2
	goto endfromcomph21
	 


endchk22        
	bsf  STATUS, RP0
	clrf Keephigh21
	clrf Keeplow21
endfromcomph21
	Return


;/////////////////////////////////////
;*************************************
Increment2


	clrf Test2122   ; set so that we can decrement after reaching 122


	
	btfsc Temp2d1, 0  ; check for 0 in row 1
	goto  Contasnormal2
	btfsc Temp2d1, 1  ; 
	goto  Contasnormal2 
	btfsc Temp2d1, 2
	goto  Contasnormal2
	btfsc Temp2d1, 3
	goto  Contasnormal2
	goto  checkrow2I2                ;if true it is a zero


checkrow2I2
	
	btfsc Temp2d2, 0  ; check for 0 in row 2
	goto  Contasnormal2
	btfsc Temp2d2, 1  
	goto  Contasnormal2 
	btfsc Temp2d2, 2
	goto  Contasnormal2
	btfsc Temp2d2, 3
	goto  Contasnormal2
	goto  checkrow3I2      



checkrow3I2 
	
	btfsc Temp2d3, 0  ; check for 4 in row 3
	goto  Contasnormal2
	btfsc Temp2d3, 1  
	goto  Contasnormal2
	btfss Temp2d3, 2
	goto  Contasnormal2
	btfsc Temp2d3, 3
	goto  Contasnormal2
	goto  Endincre2




; check first then increment

Contasnormal2
	incf Temp2d1, 1


	movlw 0xC0    ;force cursor begining of second line
	movwf PORTB
	call Sendcont


	movlw 0x14
	movwf PORTB
	movlw 0x0B      ;11 times
	movwf DelayL1
loop2I2  call Sendcont	
	decfsz DelayL1
        goto loop2I2
	
	movlw 0x30
	addwf Temp2d1, 0   ;convert to ascii for LCD
	movwf PORTB         
	movwf Tempincre2
	call Senddata

	btfss Tempincre2, 3  ; check if 8,9,A 100x, I'm looking for a 9
	goto  Endincre2
	btfss Tempincre2, 1  ; check if A   1001
	goto Endincre2       ;if not an 9 go to end of routine
	
	movlw 0xC0          ;before leaving clear row 1 to zero/set tempincre to 1
	movwf PORTB
	call Sendcont
	movlw 0x14
	movwf PORTB
	movlw 0x0B      ;11 times
	movwf DelayL1
loop4I2  call Sendcont	
	decfsz DelayL1
        goto loop4I2


	movlw 0x30  
	movwf PORTB
	call Senddata
	clrf Temp2d1        ;very much needed.
	clrf Tempincre2      ;needed?????     
	incf Temp2d2, 1
	goto  goto20x0
	
;--------------------------------0x0	       
goto20x0    ;routine for incrementing 2nd row/ 
	
	movlw 0xC0
	movwf PORTB
	call Sendcont

	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x0A      ;10 times
	movwf DelayL1
loop3I2  call Sendcont	
	decfsz DelayL1
        goto loop3I2

	movlw 0x30
	addwf Temp2d2, 0   ;convert to ascii for LCD
	movwf PORTB         
	movwf Tempincre2
	call Senddata

	btfss Tempincre2, 3  ; check if 8,9,A 100x, I'm looking for a 9
	goto  Endincre2
	btfss Tempincre2, 1  ; check if A   1001
	goto Endincre2       ;if not an 9 go to end of routine
	
	movlw 0xC0          ;before leaving clear row to zero/set tempincre to 1
	movwf PORTB
	call Sendcont
	movlw 0x14
	movwf PORTB
	movlw 0x0A      ;10 times
	movwf DelayL1
loop5I2  call Sendcont	
	decfsz DelayL1
        goto loop5I2

	movlw 0x30          ;
	movwf PORTB
	call Senddata
	clrf Tempincre2      ;needed?????     
;zzzzzzzzzzzzzz added when was working until 109
	clrf Temp2d1        ;very much needed.
	clrf Tempincre2      ;needed?????     
;zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	incf Temp2d3, 1
	goto  goto2x00
;-----------------------------------x00----------	      
goto2x00

	movlw 0xC0
	movwf PORTB
	call Sendcont

	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x09      ;10 times
	movwf DelayL1
loop6I2 call Sendcont	
	decfsz DelayL1
        goto loop6I2

	movlw 0x30
	addwf Temp2d3, 0   ;convert to ascii for LCD
	movwf PORTB         
	movwf Tempincre2
	call Senddata

	clrf Temp2d1        ;very much needed.
	clrf Temp2d2        ;vmn
	clrf Tempincre2      ;needed?????     

Endincre2


	Return
;////////////////////////////////////
;************************************
Decrement2
	btfsc Test2122, 0
	goto endrerou2


	btfsc Temp2d1, 0  ; check for 0 in row 1
	goto  outrow21
	btfsc Temp2d1, 1  ; 
	goto  outrow21    
	btfsc Temp2d1, 2
	goto  outrow21
	btfsc Temp2d1, 3
	goto  outrow21
	goto  checkrow22F                ;if true it is a 2


checkrow22F
	

	
	btfsc Temp2d2, 0  ; check for 0 in row 2
	goto  outrow22
	btfsc Temp2d2, 1  
	goto  outrow22    
	btfsc Temp2d2, 2
	goto  outrow22
	btfsc Temp2d2, 3
	goto  outrow22
	goto  checkrow33F      



checkrow33F 
	


	btfsc Temp2d3, 0  ; check for 0 in row 3
	goto  outrow33
	btfsc Temp2d3, 1  
	goto  outrow33    
	btfsc Temp2d3, 2
	goto  outrow33
	btfsc Temp2d3, 3
	goto  outrow33
	goto  enddecre2


;-----------------------------------------------00x
outrow21
	decf Temp2d1, 1
	movlw 0xC0
	movwf PORTB
	call Sendcont

	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x0B      ;11 times
	movwf DelayL1
loop3D2  call Sendcont	
	decfsz DelayL1
        goto loop3D2

	movlw 0x30
	addwf Temp2d1, 0   ;convert to ascii for LCD
	movwf PORTB         
	movwf Tempincre2
	call Senddata
	goto enddecre2

;---------------------------------------0x0
outrow22
	
	;first we must reset first column to 9
	
	movlw 0xC0
	movwf PORTB
	call Sendcont
	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x0B      ;11 times
	movwf DelayL1
loopw22  call Sendcont	
	decfsz DelayL1
        goto loopw22
	movlw 0x09
	movwf Temp2d1 ;put 9 into temp2d1 but dont change when converting to ascii
	movlw 0x30  ;
	addwf Temp2d1, 0   ;convert to ascii for LCD
	movwf PORTB         
	call Senddata
;**
	decf Temp2d2, 1
;**
	movlw 0xC0
	movwf PORTB
	call Sendcont

	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x0A      ;10 times
	movwf DelayL1
loop4D2  call Sendcont	
	decfsz DelayL1
        goto loop4D2

	movlw 0x30
	addwf Temp2d2, 0   ;convert to ascii for LCD
	movwf PORTB         
	movwf Tempincre2
	call Senddata
	goto enddecre2

;---------------------------------------x00
outrow33
	
	;first we must reset second and firts columns to 9

; first column
	movlw 0xC0
	movwf PORTB
	call Sendcont
	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x0A      ;10 times
	movwf DelayL1
loopw32  call Sendcont	
	decfsz DelayL1
        goto loopw32



	movlw 0x09
	movwf Temp2d2
	movlw 0x30  ;
	addwf Temp2d2, 0   ;convert to ascii for LCD
	movwf PORTB         
	call Senddata
;first

	movlw 0xC0
	movwf PORTB
	call Sendcont
	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x0B      ;11 times
	movwf DelayL1
loopw312  call Sendcont	
	decfsz DelayL1
        goto loopw312



	movlw 0x09
	movwf Temp2d1 ;reset it to 9
	movlw 0x30  ;
	addwf Temp2d2, 0   ;convert to ascii for LCD
	movwf PORTB         
	call Senddata



;***
	decf Temp2d3, 1
;***	
	movlw 0xC0
	movwf PORTB
	call Sendcont

	movlw 0x14  ; move cursor to the right
	movwf PORTB
	movlw 0x09      ;9 times
	movwf DelayL1
loop5D2  call Sendcont	
	decfsz DelayL1
        goto loop5D2

	movlw 0x30
	addwf Temp2d3, 0   ;convert to ascii for LCD
	movwf PORTB         
	movwf Tempincre2
	call Senddata
	goto enddecre2


enddecre2
;test for 122


	btfsc Temp2d1, 0  ; check for 2 in row 1
	goto  endrerou2
	btfss Temp2d1, 1  ; 
	goto  endrerou2    
	btfsc Temp2d1, 2
	goto  endrerou2
	btfsc Temp2d1, 3
	goto  endrerou2
	goto  eckrow22F                ;if true it is a 2


eckrow22F
	

	
	btfsc Temp2d2, 0  ; check for 2 in row 2
	goto  endrerou2
	btfss Temp2d2, 1  
	goto  endrerou2 
	btfsc Temp2d2, 2
	goto  endrerou2
	btfsc Temp2d2, 3
	goto  endrerou2
	goto  eckrow33F      



eckrow33F 
	


	btfss Temp2d3, 0  ; check for 1 in row 3
	goto  endrerou2
	btfsc Temp2d3, 1  
	goto  endrerou2  
	btfsc Temp2d3, 2
	goto  endrerou2
	btfsc Temp2d3, 3
	goto  endrerou2
	movlw 0xFF
	movwf Test2122

endrerou2

	Return
;////////////////////////////////////
;***********************************
Senddata
	bsf PORTD, 0     ; set d0 for data select register 
	bsf PORTD, 7     ; enable high for 1ms
	call VSdelay
	bcf PORTD, 7	 ;enable low for 1ms
	call VSdelay
	bsf PORTD, 0     ;set d0 to high again
	return
;///////////////////////////////////////

;****************************************
Sendcont 	;only small delay, will not work with initializing LCD
	bcf PORTD, 0     ; set d0 for control register
	bsf PORTD, 7     ; enable high for 1ms
	call VSdelay
	bcf PORTD, 7	 ;enable low for 1ms
	call VSdelay
	bsf PORTD, 0     ;set d0 to high again
	return
;///////////////////////////////////////
;**************************************
;Ports initialization routine
Portsinit
	banksel OPTION_REG
	bcf   OPTION_REG, 7     ; turn on internal weak pull up
	bcf STATUS, RP0
	bcf STATUS, RP1         ;bank 0
	clrf PORTB
	clrf PORTD
	clrf PORTA
 	bsf  STATUS, RP0	;bank  1
	movlw 0x06	 
 	movwf ADCON1
	
	movlw 0x00      ;all outputs   
 	movwf TRISB
	
	movlw 0x7E
	movwf TRISD     ;
	
	movlw 0x00
	movwf TRISA     ;all outputs	


	return
;//////////////////////////////////////

;**************************************
;LCD init routine
Lcdinit
	bcf PORTD, 0     ; set d0 to low/select instruction register
	movlw 0x0C
	movwf PORTB      ; send init display
	bsf PORTD, 7     ; enable high for 40 ms
	call Sdelay
	bcf PORTD, 7	 ;enable low for 40ms
	call Sdelay
	movlw 0x01   
	movwf PORTB 	 ;send clear display
	bsf PORTD, 7     ; enable high for 40 ms
	call Sdelay
	bcf PORTD, 7	 ;enable low for 40ms
	movlw 0x38
	movwf PORTB 	 ;send dual line/ 8 bits
	bsf PORTD, 7     ; enable high for 40 ms
	call Sdelay
	bcf PORTD, 7	 ;enable low for 40ms
	call Sdelay	
	return
;////////////////////////////////////////
;****************************************
;Enable routine
Enable
	bsf PORTD, 7     ;
	call VSdelay
	bcf PORTD, 7	 ;
	call VSdelay
	return
;/////////////////////////////////////////

;*******************************************
SendtempF1
		
	btfsc Temp1d3, 0   ;3
	goto  oneorthree 
	btfsc Temp1d3, 1  
	goto  twoorthree    
	btfsc Temp1d3, 2
	nop
	goto four 
  
	
	

oneorthree	
	btfsc Temp1d3, 1  ;3
	goto three
	goto one

twoorthree

	btfsc Temp1d3, 0
	goto three
	goto two
;***********************************************
one                         ;16%
	
	btfss Temp1d2,0	
	goto zo2o4o6o8	
	goto zo3o5o7o9




zo2o4o6o8	
	btfss Temp1d2, 1
	goto  fo8	
	goto  to6
	
zo3o5o7o9
	
	btfss Temp1d2, 1
	goto zo5o9
	goto to7


zo5o9   btfss Temp1d2,2
	goto  nine1   ;because there is no 11x, but 122	
	goto five1



to6
	btfss Temp1d2, 2
	goto two1
	goto six1

fo8	btfss Temp1d2, 2
	goto eight1
	goto four1

to7	
	btfss Temp1d2, 2
	goto three1
	goto seven1



two1				  	   

	bsf PORTA, 0
	call Delay10
 	bcf PORTA, 0
	goto Endsendpower

 
three1

	bsf PORTA, 0
	call Delay10
	call VSdelay
	bcf PORTA, 0

       goto Endsendpower

four1
	bsf PORTA, 0
	call Delay10
	call Delay10
	bcf PORTA, 0
	goto Endsendpower

five1
	bsf PORTA, 0
	call Delay10
	call Delay10
	call Delay10
	bcf PORTA, 0
	goto Endsendpower



six1
	bsf PORTA, 0
	call Delay10
	call Delay10
	call Delay10
	call Delay10
	bcf PORTA, 0
	goto Endsendpower	

seven1
	bsf PORTA, 0
	movlw 0x04      
	movwf DelayL1
lpseven1  call Delay10	
	decfsz DelayL1
        goto lpseven1
	
	bcf PORTA, 0
	goto Endsendpower	



eight1
	bsf PORTA, 0
	movlw 0x05      
	movwf DelayL1
lpeight1 call Delay10	
	decfsz DelayL1
        goto lpeight1
	

	bcf PORTA, 0
	goto Endsendpower

nine1
	bsf PORTA, 0
	movlw 0x06      
	movwf DelayL1
lpnine1 call Delay10	
	decfsz DelayL1
        goto lpnine1
 	bcf PORTA, 0
	goto Endsendpower
;*******************************************************
two                         ;33.33%

	btfss Temp1d2,0	
	goto zo2o4o6o8s	
	goto oo3o5o7o9s




zo2o4o6o8s	
	btfss Temp1d2, 1
	goto  fo8s	
	goto  to6s
	
oo3o5o7o9s
	
	btfss Temp1d2, 1
	goto oo5o9s
	goto to7s


oo5o9s   btfss Temp1d2,2
	goto  oo9s   ;because there is no 11x, but 122	
	goto five2


oo9s	

	btfss Temp1d2, 3
	goto one2
	goto nine2
to6s
	btfss Temp1d2, 2
	goto two2
	goto six2

fo8s	btfss Temp1d2, 2
	goto eight2
	goto four2

to7s	
	btfss Temp1d2, 2
	goto three2
	goto seven2


one2
	bsf PORTA, 0
	movlw 0x06  
	movwf DelayL1
lpone2  call Delay10	
	decfsz DelayL1
        goto lpone2
	bcf PORTA, 0	
	goto Endsendpower



two2				  	   ;1

	bsf PORTA, 0
	movlw 0x06  
	movwf DelayL1
lptwo2  call Delay10	
	decfsz DelayL1
        goto lptwo2
	call Sdelay
 	bcf PORTA, 0
	goto Endsendpower

 
three2

	bsf PORTA, 0
	movlw 0x07  
	movwf DelayL1
lpthree2  call Delay10	
	decfsz DelayL1
        goto lpthree2
	bcf PORTA, 0

       goto Endsendpower

four2
	bsf PORTA, 0
	movlw 0x07  
	movwf DelayL1
lpfour2  call Delay10	
	decfsz DelayL1
        goto lpfour2
	call Sdelay
	bcf PORTA, 0
	goto Endsendpower

five2
	bsf PORTA, 0
	movlw 0x08  
	movwf DelayL1
lpfive2  call Delay10	
	decfsz DelayL1
        goto lpfive2
	bcf PORTA, 0
	goto Endsendpower



six2
	bsf PORTA, 0
	movlw 0x08  
	movwf DelayL1
lpsix2  call Delay10	
	decfsz DelayL1
        goto lpsix2	
	call Sdelay
	bcf PORTA, 0
	goto Endsendpower	

seven2
	bsf PORTA, 0
	movlw 0x09  
	movwf DelayL1
lpseven2 call Delay10	
	decfsz DelayL1
        goto lpseven2

	bcf PORTA, 0
	goto Endsendpower	



eight2
	bsf PORTA, 0
	movlw 0x09  
	movwf DelayL1
lpeight2  call Delay10	
	decfsz DelayL1
        goto lpeight2
	call Sdelay
	bcf PORTA, 0
	goto Endsendpower

nine2
	bsf PORTA, 0
	movlw 0x0A  
	movwf DelayL1
lpnine2 call Delay10	
	decfsz DelayL1
        goto lpnine2
 	bcf PORTA, 0
	goto Endsendpower


;********************************************************
three 
	btfss Temp1d2,0	
	goto zo2o4o6o8t	
	goto oo3o5o7o9t


zo2o4o6o8t	
	btfss Temp1d2, 1
	goto  fo8t	
	goto  to6t
	
oo3o5o7o9t
	
	btfss Temp1d2, 1
	goto oo5o9t
	goto to7t


oo5o9t   btfss Temp1d2,2
	goto  oo9t   ;because there is no 11x, but 122	
	goto five3


oo9t	

	btfss Temp1d2, 3
	goto one3
	goto nine3
to6t
	btfss Temp1d2, 2
	goto two3
	goto six3

fo8t	btfss Temp1d2, 2
	goto eight3
	goto four3

to7t	
	btfss Temp1d2, 2
	goto three3
	goto seven3


one3
	bcf PORTA, 0
	movlw 0x09  
	movwf DelayL1
lpone3  call Delay10	
	decfsz DelayL1
        goto lpone3	
	bsf PORTA, 0	
	goto Endsendpower



two3				  

	bcf PORTA, 0
	movlw 0x08  
	movwf DelayL1
lptwo3  call Delay10	
	decfsz DelayL1
        goto lptwo3	
 	bsf PORTA, 0
	goto Endsendpower

 
three3

	 bcf PORTA, 0
	 movlw 0x07  
	 movwf DelayL1
lpthree3 call Delay10	
	 decfsz DelayL1
         goto lpthree3	
	 bsf PORTA, 0

       goto Endsendpower

four3
	bcf PORTA, 0
	movlw 0x06  
	movwf DelayL1
lpfour3 call Delay10	
	decfsz DelayL1
        goto lpfour3	
	bsf PORTA, 0
	goto Endsendpower

five3
	 bcf PORTA, 0
	 movlw 0x05  
	 movwf DelayL1
lpfive3  call Delay10	
	 decfsz DelayL1
         goto lpfive3	
	 bsf PORTA, 0
	 goto Endsendpower



six3
	bcf PORTA, 0
	movlw 0x04  
	movwf DelayL1
lpsix3  call Delay10	
	decfsz DelayL1
        goto lpsix3	
	bsf PORTA, 0
	goto Endsendpower	

seven3
	bcf PORTA, 0
	call Delay10
	call Delay10
	call Delay10
	bsf PORTA, 0
	goto Endsendpower	



eight3
	bcf PORTA, 0
	call Delay10
	call Delay10
	bsf PORTA, 0
	goto Endsendpower

nine3
	bcf PORTA, 0
	call Delay10
	bsf PORTA, 0
	goto Endsendpower
;********************************************************
four                        ;100%


	bsf PORTA, 0

Endsendpower

	Return
;//////////////////////////////////////////
;*****************************************
;***************************************
SendtempF2
		
	btfsc Temp2d3, 0
	goto  oneorthreeF2 
	btfsc Temp2d3, 1  
	goto  twoorthreeF2    
	btfsc Temp2d3, 2
	nop
	goto four2 
  
	
oneorthreeF2	
	btfsc Temp2d3, 1
	goto threeF2
	goto oneF2

twoorthreeF2

	btfsc Temp2d3, 0
	goto threeF2
	goto twoF2
;***********************************************
oneF2                         ;16%
	
	btfss Temp2d2,0	
	goto zo2o4o6o8F2	
	goto zo3o5o7o9F2




zo2o4o6o8F2	
	btfss Temp2d2, 1
	goto  fo8F2	
	goto  to6F2
	
zo3o5o7o9F2
	
	btfss Temp2d2, 1
	goto zo5o9F2
	goto to7F2


zo5o9F2 btfss Temp2d2,2
	goto  nine1F2   ;because there is no 11x, but 122	
	goto five1F2



to6F2
	btfss Temp2d2, 2
	goto two1F2
	goto six1F2

fo8F2	btfss Temp2d2, 2
	goto eight1F2
	goto four1F2

to7F2	
	btfss Temp2d2, 2
	goto three1F2
	goto seven1F2



two1F2

	bsf PORTA, 1
	call Delay10
 	bcf PORTA, 1
	goto Endsendpower2

 
three1F2

	bsf PORTA, 1
	call Delay10
	call VSdelay
	bcf PORTA, 1

       goto Endsendpower2

four1F2
	bsf PORTA, 1
	call Delay10
	call Delay10
	bcf PORTA, 1
	goto Endsendpower2

five1F2
	bsf PORTA, 1
	call Delay10
	call Delay10
	call Delay10
	bcf PORTA, 1
	goto Endsendpower2



six1F2
	bsf PORTA, 1
	call Delay10
	call Delay10
	call Delay10
	call Delay10
	bcf PORTA, 1
	goto Endsendpower2	

seven1F2
	bsf PORTA, 1
	movlw 0x04      
	movwf DelayL1
lpseven1F2  call Delay10	
	decfsz DelayL1
        goto lpseven1F2
	
	bcf PORTA, 1
	goto Endsendpower2	



eight1F2
	bsf PORTA, 1
	movlw 0x05      
	movwf DelayL1
lpeight1F2 call Delay10	
	decfsz DelayL1
        goto lpeight1F2
	bcf PORTA, 1
	goto Endsendpower2

nine1F2
	bsf PORTA, 1
	movlw 0x06      
	movwf DelayL1
lpnine1F2 call Delay10	
	decfsz DelayL1
        goto lpnine1F2
 	bcf PORTA, 1
	goto Endsendpower2
;*******************************************************
twoF2                         ;33.33%

	btfss Temp2d2,0	
	goto zo2o4o6o8sF2	
	goto oo3o5o7o9sF2




zo2o4o6o8sF2	
	btfss Temp2d2, 1
	goto  fo8sF2	
	goto  to6sF2
	
oo3o5o7o9sF2
	
	btfss Temp2d2, 1
	goto oo5o9sF2
	goto to7sF2


oo5o9sF2 btfss Temp2d2,2
	 goto  oo9sF2   ;because there is no 11x, but 122	
	 goto  five2F2


oo9sF2	

	btfss Temp2d2, 3
	goto one2F2
	goto nine2F2
to6sF2
	btfss Temp2d2, 2
	goto two2F2
	goto six2F2

fo8sF2	btfss Temp2d2, 2
	goto eight2F2
	goto four2F2

to7sF2	
	btfss Temp2d2, 2
	goto three2F2
	goto seven2F2


one2F2
	bsf PORTA, 1
	movlw 0x06  
	movwf DelayL1
lpone2F2  call Delay10	
	decfsz DelayL1
        goto lpone2F2
	bcf PORTA, 1	
	goto Endsendpower2



two2F2				  	   ;1

	bsf PORTA, 1
	movlw 0x06  
	movwf DelayL1
lptwo2F2  call Delay10	
	decfsz DelayL1
        goto lptwo2F2
	call Sdelay
 	bcf PORTA, 1
	goto Endsendpower2

 
three2F2

	bsf PORTA, 1
	movlw 0x07  
	movwf DelayL1
lpthree2F2  call Delay10	
	decfsz DelayL1
        goto lpthree2F2
	bcf PORTA, 1

       goto Endsendpower2


four2F2
	bsf PORTA, 1
	movlw 0x07  
	movwf DelayL1
lpfour2F2  call Delay10	
	decfsz DelayL1
        goto lpfour2F2
	call Sdelay
	bcf PORTA, 1
	goto Endsendpower2

five2F2
	bsf PORTA, 1
	movlw 0x08  
	movwf DelayL1
lpfive2F2  call Delay10	
	decfsz DelayL1
        goto lpfive2F2
	bcf PORTA, 1
	goto Endsendpower2



six2F2
	bsf PORTA, 1
	movlw 0x08  
	movwf DelayL1
lpsix2F2  call Delay10	
	decfsz DelayL1
        goto lpsix2F2	
	call Sdelay
	bcf PORTA, 1
	goto Endsendpower2	

seven2F2
	bsf PORTA, 1
	movlw 0x09  
	movwf DelayL1
lpseven2F2 call Delay10	
	decfsz DelayL1
        goto lpseven2F2
	bcf PORTA, 1
	goto Endsendpower2	



eight2F2
	bsf PORTA, 1
	movlw 0x09  
	movwf DelayL1
lpeight2F2  call Delay10	
	decfsz DelayL1
        goto lpeight2F2
	call Sdelay
	bcf PORTA, 1
	goto Endsendpower2

nine2F2
	bsf PORTA, 1
	movlw 0x0A  
	movwf DelayL1
lpnine2F2 call Delay10	
	decfsz DelayL1
        goto lpnine2F2
 	bcf PORTA, 1
	goto Endsendpower2
;********************************************************
threeF2 
	btfss Temp2d2,0	
	goto zo2o4o6o8tF2	
	goto oo3o5o7o9tF2


zo2o4o6o8tF2	
	btfss Temp2d2, 1
	goto  fo8tF2	
	goto  to6tF2
	
oo3o5o7o9tF2
	
	btfss Temp2d2, 1
	goto oo5o9tF2
	goto to7tF2


oo5o9tF2  btfss Temp2d2,2
	goto  oo9tF2   ;because there is no 11x, but 122	
	goto five3F2


oo9tF2	

	btfss Temp2d2, 3
	goto one3F2
	goto nine3F2
to6tF2
	btfss Temp2d2, 2
	goto two3F2
	goto six3F2

fo8tF2	btfss Temp2d2, 2
	goto eight3F2
	goto four3F2

to7tF2	
	btfss Temp2d2, 2
	goto three3F2
	goto seven3F2


one3F2
	bcf PORTA, 1
	movlw 0x09  
	movwf DelayL1
lpone3F2  call Delay10	
	decfsz DelayL1
        goto lpone3F2	
	bsf PORTA, 1	
	goto Endsendpower2



two3F2				  

	bcf PORTA, 1
	movlw 0x08  
	movwf DelayL1
lptwo3F2  call Delay10	
	decfsz DelayL1
        goto lptwo3F2	
 	bsf PORTA, 1
	goto Endsendpower2

 
three3F2

	 bcf PORTA, 1
	 movlw 0x07  
	 movwf DelayL1
lpthree3F2 call Delay10	
	 decfsz DelayL1
         goto lpthree3F2	
	 bsf PORTA, 1

       goto Endsendpower2

four3F2
	bcf PORTA, 1
	movlw 0x06  
	movwf DelayL1
lpfour3F2 call Delay10	
	decfsz DelayL1
        goto lpfour3F2	
	bsf PORTA, 1
	goto Endsendpower2

five3F2
	 bcf PORTA, 1
	 movlw 0x05  
	 movwf DelayL1
lpfive3F2  call Delay10	
	 decfsz DelayL1
         goto lpfive3F2	
	 bsf PORTA, 1
	 goto Endsendpower2



six3F2
	bcf PORTA, 1
	movlw 0x04  
	movwf DelayL1
lpsix3F2  call Delay10	
	decfsz DelayL1
        goto lpsix3F2	
	bsf PORTA, 1
	goto Endsendpower2	

seven3F2
	bcf PORTA, 1
	call Delay10
	call Delay10
	call Delay10
	bsf PORTA, 1
	goto Endsendpower2	



eight3F2
	bcf PORTA, 1
	call Delay10
	call Delay10
	bsf PORTA, 1
	goto Endsendpower2

nine3F2
	bcf PORTA, 1
	call Delay10
	bsf PORTA, 1
	goto Endsendpower2
;********************************************************
fourF2                        ;100%


	bsf PORTA, 1

Endsendpower2
	Return

;/////////////////////////////////////
;***************************************
Clearlcd			
	bcf PORTD, 0     ; set d0 to low/select instruction register
	movlw 0x01   
	movwf PORTB 	 ;send clear display
	bsf PORTD, 7     ; enable high for 40 ms
	call Sdelay
	bcf PORTD, 7	 ;enable low for 40ms
	call Sdelay
	Return
;***************************************
;***************************************
; --------------------------------
; ABOUT A 1mS SECOND DELAY 
; --------------------------------
;
BigDel	
	movlw 0x3F                     ; change !!!!!!!!!!!!!3f!!!!!!!11
	movwf DelayL
	movwf DelayM
	movlw 1h    ; 0.1 of second more or less
	movwf DelayH
BDloop	decfsz DelayL
	goto BDloop
	decfsz DelayM
	goto BDloop
	decfsz DelayH
	goto BDloop
	return
;/////////////////////////////////

;*********************************
;40ms delay
Sdelay
	clrf DelayL
	movlw 0x20		;    change!!!!!0x20!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
	movwf DelayH
sdel    decfsz DelayL
        goto sdel
	decfsz DelayH
	goto sdel
	return
;/////////////////////////////////

;********************************
;200 uS delay
VSdelay
	movlw 0xAF          ;change!!!!!!!!!0xAF!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
	movwf DelayL
kdloop  decfsz DelayL
        goto kdloop
        return
;/////////////////////////////
;********************* 10ms delay
Delay10
	
	movlw 0x10             ; change !!!!!!!!!!!!!10!!!!!!!11
	movwf DelayL
	movwf DelayM
	movlw 1h    ; 0.1 of second more or less
	movwf DelayH
BDoop	decfsz DelayL
	goto BDoop
	decfsz DelayM
	goto BDoop
	decfsz DelayH
	goto BDoop
	nop
	Return
;/////////////////////////////////////////
;**************************************
WEEprom
	BSF	STATUS, RP1
	bcf	STATUS, RP0
	movlw	0x01
	movwf 	EEADR
	bcf	STATUS, RP1
	bsf	STATUS, RP0 ;bank1 for temp1d1 ???? weird
	movf  	Temp1d1,0
	BSF	STATUS, RP1
	bcf	STATUS, RP0
	movwf 	EEDATA
	bsf  	STATUS, RP0
	bcf	EECON1, EEPGD
	bsf	EECON1, WREN
	; no interrupts don disable anything

	movlw	0x55
	movwf	EECON2
	movlw	0xAA
	movwf	EECON2
	bsf	EECON1, WR     ;start write operation
	bcf	EECON1, WREN   ;disables writes  
	BSF	STATUS, RP1
	BSF	STATUS, RP0
HOLD	BTFSC	EECON1, WR
	GOTO	HOLD	
	return
;///////////////////////////////////////
;***************************************
REEprom
	BSF	STATUS, RP1
	BCF	STATUS, RP0
	MOVF	ADDR, 0
	MOVWF	EEADR
	BSF	STATUS, RP0
	BCF	EECON1, EEPGD
	BSF	EECON1, RD
	BCF	STATUS, RP0
	MOVF	EEDATA, 0
	bcf	STATUS, RP1
	bsf	STATUS, RP0 ;bank1 for temp1d1 ???? weird
	MOVWF 	Temp1d1

	return
;///////////////////////////////////////